#ifndef __GSL_DISTFIT_EVAL_H__
#define __GSL_DISTFIT_EVAL_H__

#include <gsl/gsl_vector.h>

void gsl_distfit_init_moments(size_t n, double *x, double *px, double *_m1, double *_m2);

double eval_gaussian(double x, const gsl_vector *p);
double eval_gaussian_dsigma(double x, const gsl_vector *p);
double eval_gaussian_dmu(double x, const gsl_vector *p);
double eval_gaussian_Pinv(double x, const gsl_vector *p);
void   init_gaussian(size_t n, double *x, double *px, gsl_vector *p);

double eval_rayleigh(double x, const gsl_vector *p);
double eval_rayleigh_dsigma(double x, const gsl_vector *p);
double eval_rayleigh_Pinv(double x, const gsl_vector *p);
void   init_rayleigh(size_t n, double *x, double *px, gsl_vector *p);

void   init_lognormal(size_t n, double *x, double *px, gsl_vector *p);
double eval_lognormal(double x, const gsl_vector *p);
double eval_lognormal_dsigma(double x, const gsl_vector *p);
double eval_lognormal_dzeta(double x, const gsl_vector *p);
double eval_lognormal_Pinv(double x, const gsl_vector *p);

double eval_weibull(double x, const gsl_vector *p);
double eval_weibull_da(double x, const gsl_vector *p);
double eval_weibull_db(double x, const gsl_vector *p);
double eval_weibull_Pinv(double x, const gsl_vector *p);
void   init_weibull(size_t n, double *x, double *px, gsl_vector *p);

double eval_exponential(double x, const gsl_vector *p);
double eval_exponential_dmu(double x, const gsl_vector *p);
double eval_exponential_Pinv(double x, const gsl_vector *p);
void   init_exponential(size_t n, double *x, double *px, gsl_vector *p);

double  eval_chisq(double x, const gsl_vector *p); 
double  eval_chisq_Pinv(double x, const gsl_vector *p); 
void    init_chisq(size_t n, double *x, double *px, gsl_vector *p); 
double  eval_chisq_dnu (double x, const gsl_vector *p);

double  eval_tdist(double x, const gsl_vector *p); 
double  eval_tdist_Pinv(double x, const gsl_vector *p); 
void    init_tdist(size_t n, double *x, double *px, gsl_vector *p); 
double  eval_tdist_dnu(double x, const gsl_vector *p);

double  eval_beta(double x, const gsl_vector *p); 
double  eval_beta_Pinv(double x, const gsl_vector *p); 
void    init_beta(size_t n, double *x, double *px, gsl_vector *p); 
double eval_beta_da (double x, const gsl_vector *p);
double eval_beta_db (double x, const gsl_vector *p);
#endif
